<template lang="pug">
.drop( 
	:class='{ "drop-active": active }' 
	@dragenter.prevent='active = true' 
	@dragover.prevent='active = true'
	@dragleave.prevent='active = false'
	@drop.prevent="onDrop" )
	slot
</template>

<script setup>
import { ref } from "vue"
import { useI18n } from "vue-i18n"
import { useToast } from "vue-toastification"

const props = defineProps({
	modelValue: {
		type: Array,
		default: () => []
	}
})

const emit = defineEmits([ "update:modelValue" ])
const { t } = useI18n()
const toast = useToast()

const active = ref(false)

const getExt = name => {
	var parts = name.split('.')
  return parts[parts.length - 1]
}

const isImage = name => {
	const ext = getExt(name).toLowerCase()
	
	return [
		"jpg",
		"png",
		"webp" 
	].includes(ext)
}

const validate = (files, fn) => {
	const invalid = []
	for (let { name } of files) {
		if (!fn(name)) return true
	}
	return false
}

const onDrop = e => {
	active.value = false

	const hasInvalid = validate(e.dataTransfer.files, isImage)
	if (hasInvalid) return toast.error(t("default.image_validate"))
	
	emit("update:modelValue", [...e.dataTransfer.files])
}
</script>

<style lang="scss" scoped>
.drop {
	min-height: 100%;
	position: relative;
	&-active {
		&::after {
			font-size: 2rem;
			color: $grey;
			font-weight: 700;
			content: "Drop files here...";
			display: flex;
			align-items: center;
			justify-content: center;
			background: $grey-light;
			border: 4px dashed $grey;
			border-radius: 4px;
			position: absolute;
			top: 0;
			right: 0;
			bottom: 0;
			left: 0;
		}
	}
}
</style>